#include <iostream>
#include <cmath>
using namespace std;

int main(int argc, char** argv) {
    string str;
    cin >> str;
    int t = 0;
    for(char c : str)
    {
        t++;
    }
    int karakteri[t];
    int pr[t/2];
    int po[t/2];
    int k = 0;
    int gpr, gpo;
    gpr = t/2-1;
    if(t%2==0)
    {
        gpo = t/2;
    }
    else
    {
        gpo = t/2+1;
    }
    for(int i = 0; i<t;i++)
    {
        pr[i]= 0;
        po[i] = 0;
        karakteri[i] = 0;
        karakteri[t-1-i] = 0;
    }
    for(char c : str)
    {
        karakteri[k] = int(c);
        if(k<=gpr)
        {
            pr[int(c) - 97]++;
        }
        else
        {
            if(k>=gpo && k<t)
            {
                po[int(c) - 97]++;
            }
        }
        k++;
    }
    
    
    int sj = 1;
    for(int i = 0; i<t/2; i++)
    {
        if(pr[i]!=po[i]) sj=0;
    }
    
    int res;
    if(sj==1)
    {
        int prvi=0;
        int zadnji = 0;
        for(int i = 0; i<gpr;i++)
        {
            if(karakteri[i]!=karakteri[t-1-i])
            {
                prvi = i;
                break;
            }
        }
        for(int i = gpo; i<t;i++)
        {
            if(karakteri[i]!=karakteri[t-1-i])
            {
                zadnji = t-i-1;
                break;
            }
        }
        res = zadnji - prvi + 1;
    }
    else
    {
        for(int i = 0; i<gpr;i++)
        {
            if(karakteri[i]!=karakteri[t-1-i])
            {
                res = t - 2*i - 1;
                break;
            }
        }
    }
    cout << res;
	return 0;
}